/*
 * TIFF/Exif metadata loader
 *  Copyright (C) 2015 Noriaki TANAKA (dtana@startide.jp)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 *  02111-1307, USA.
 *
 * $Id: tiffmd.h,v 1.1 2016/01/30 16:32:37 dtana Exp $
 */
#ifndef TIFFMD_H
#define TIFFMD_H

struct tiffmd;
struct tiffmd *load_tiffmd(FILE *);
void term_tiffmd(struct tiffmd *);
const struct tiffmd *find_tiffmd(const struct tiffmd *, unsigned);
const struct tiffmd *find_tiffmd_node(const struct tiffmd *,
    unsigned, int);

int  tiffmd_getd(char *, size_t, const struct tiffmd *);
int  tiffmd_getn(int d[], int n, const struct tiffmd *, int);
int  tiffmd_setn(const int d[], int n, struct tiffmd *, int);

int  tiffmd_pute(const struct tiffmd *, char *, size_t);
void tiffmd_set_disable(struct tiffmd *);

int  tiffmd_xo(const struct tiffmd *);
int  tiffmd_tag(const char *);

int  list_tiffmd(const struct tiffmd *p, int h);
void dump_tiffmd(char *, int, const struct tiffmd *);

enum {
	TIFF_NOTYPE = 0,
	TIFF_BYTE,
	TIFF_ASCII,
	TIFF_SHORT,
	TIFF_LONG,
	TIFF_RATIONAL,
	TIFF_SBYTE,
	TIFF_UNDEFINED,
	TIFF_SSHORT,
	TIFF_SLONG,
	TIFF_SRATIONAL,
	TIFF_FLOAT,
	TIFF_DOUBLE,
	TIFF_IFD,

	TIFF_LONG8  = 16,
	TIFF_SLONG8,
	TIFF_IFD8
};

#endif
